;;;********************************************************************
;;;                     
;;;	                    7242-81  8338-75
;;;                            KS_Podsh.lsp v.1
;;;                 Copyright,2002        ..
;;;                               3.07.02
;;;********************************************************************

(defun c:ks_podsh ()
  (setq	sosnap	(getvar "osmode")
	cmd	(getvar "cmdecho")
	oldtp	(getvar "celtype")
	oldcl	(getvar "cecolor")
	nam1	(findfile "support/KS_Podsh/KS_podsh.dcl")
        dcl_id	(load_dialog nam1)
	no1	"0"
	no2	"0"
	wrong	1
	ss	nil
	ss1     nil
  )
  (setvar "cmdecho" 0)
  (if (new_dialog "Podsh" dcl_id)
    (progn
      (update_p)
      (shim_p)
      (action_tile "gost" "(progn (setq no2 $value) (shim_p))")
      (action_tile "nomer" "(progn (setq no1 $value) (update_p))")
      (action_tile "accept" "(done_dialog)")
      (action_tile "cancel" "(progn (setq wrong 0) (done_dialog))")
      (action_tile "info" "(abpr_p)")
      (action_tile "help" "(hlp_p)")
      (start_dialog)
      (unload_dialog dcl_id)
    )
    (exit)
  )
  (if (/= wrong 0) (ris_p))
  (setvar "cmdecho" cmd)
  (setq cmd nil sosnap nil wrong nil dcl_id nil nam nil nam1 nil a nil aa nil disc1 nil disc2 nil
        no1 nil no2 nil ss nil ss2 nil r1 nil
        inf_p nil name1 nil aby nil orx nil help_p nil
        dvn_t nil dna_t nil b_t nil r_t nil dt_t nil dv2_t nil dn2_t nil c_t nil c0_t nil k_t nil j_t nil
	dvn nil dna nil b  nil r nil dt nil dv2 nil dn2 nil c nil c0  nil k nil j nil
	p1 nil x nil bm nil alfa nil
	pv2 nil pv21 nil pv22 nil pv23 nil pn2 nil pn21 nil pn22 nil
	pv3 nil pv31 nil pv32 nil pv33 nil pn3 nil pn31 nil pn32 nil pk1 nil
	pln2 nil pln3 nil pl21 nil pl31 nil
	p7n2 nil p7n3 nil p722 nil p732 nil p723 nil p733 nil
	plv2 nil plv3 nil pl22 nil pl32 nil
	p7v2 nil p7v3 nil p724 nil p734 nil p725 nil p735 nil
	ps21 nil ps22 nil ps23 nil ps31 nil ps32 nil ps33 nil
	blkDat nil bn nil count nil Obj nil Objd nil Onjn nil blkName nil insDat nil insName nil
  )
  (princ)
)

;===== =====

(defun shim_p ( )
   (setq orx (dimx_tile "image")
	 aby (dimy_tile "image")
   )
   (cond
      ((= no2 "0") (setq name1 "support/KS_Podsh/KS_Podsh(7242).slb"
			 disc1 "    "
			 disc2 "     "))
      ((= no2 "1") (setq name1 "support/KS_Podsh/KS_Podsh(8338).slb"
			 disc1 "    "
			 disc2 "  "))
   )
   (start_image "image")
   (fill_image 0 0 orx aby 444)
   (slide_image 0 0 orx aby name1)
   (end_image)
   (set_tile "discript1" disc1)
   (set_tile "discript2" disc2)
)

;=====      =====

(defun update_p ()
  (setq	nam  (findfile "support/KS_Podsh/KS_Podsh.dat")
 	x    (open nam "r")
	a    (read-line x)
	aa   (read a)
	no   (atoi no1)
  )
  (cond	((= no 0) (setq r1 (cdr (assoc '200 aa))))
	((= no 1) (setq r1 (cdr (assoc '201 aa))))
	((= no 2) (setq r1 (cdr (assoc '202 aa))))
	((= no 3) (setq r1 (cdr (assoc '203 aa))))
	((= no 4) (setq r1 (cdr (assoc '204 aa))))
	((= no 5) (setq r1 (cdr (assoc '205 aa))))
	((= no 6) (setq r1 (cdr (assoc '206 aa))))
	((= no 7) (setq r1 (cdr (assoc '207 aa))))
	((= no 8) (setq r1 (cdr (assoc '208 aa))))
	((= no 9) (setq r1 (cdr (assoc '209 aa))))
	((= no 10) (setq r1 (cdr (assoc '210 aa))))
	((= no 11) (setq r1 (cdr (assoc '211 aa))))
  )
  (setq dvn_t (nth 0 r1)
        dna_t (nth 1 r1)
        b_t  (nth 2 r1)
        r_t  (nth 3 r1)
	dt_t (nth 4 r1)
	dv2_t (nth 5 r1)
        dn2_t (nth 6 r1)
        c_t  (nth 7 r1)
        c0_t  (nth 8 r1)
	k_t (nth 9 r1)
	j_t (nth 10 r1)
  )

  (set_tile "dvn" dvn_t)
  (set_tile "dna" dna_t)
  (set_tile "b" b_t)
  (set_tile "r" r_t)
  (set_tile "dt" dt_t)
  (set_tile "dv2" dv2_t)
  (set_tile "dn2" dn2_t)
  (set_tile "c" c_t)
  (set_tile "c0" c0_t)
  (set_tile "k" k_t)
  (set_tile "j" j_t)
)

;===== =====

(defun ris_p ()
  (setq p1   (getpoint "\n : ")
        dv   (/ (atof dvn_t) 2)
	dn   (/ (atof dna_t) 2)
	b    (atof b_t)
	r    (atof r_t)
	dt   (/ (atof dt_t) 2)
	x    (- dt r)
	bm   (sqrt (- (* dt dt) (* x x)))
	alfa (atan (/ bm x))
  )
  (setq pv2  (list (car p1) (+ (cadr p1) dv))
	pv21 (list (car pv2) (+ (cadr pv2) r))
	pv22 (list (+ (car pv2) r) (cadr pv2))
	pv23 (list (+ (car pv2) r) (+ (cadr pv2) r))
	 pn2  (list (car p1) (+ (cadr p1) dn))
	 pn21 (list (car pn2) (- (cadr pn2) r))
	 pn22 (list (+ (car pn2) r) (cadr pn2))
	pv3  (list (+ (car p1) b) (+ (cadr p1) dv))
	pv31 (list (car pv3) (+ (cadr pv3) r))
	pv32 (list (- (car pv3) r) (cadr pv3))
	pv33 (list (- (car pv3) r) (+ (cadr pv3) r))
	 pn3  (list (+ (car p1) b) (+ (cadr p1) dn))
	 pn31 (list (car pn3) (- (cadr pn3) r))
	 pn32 (list (- (car pn3) r) (cadr pn3))
	pk1  (list (+ (car p1) (/ b 2)) (+ (cadr p1) (/ (+ dv dn) 2)))
	 pln2 (list (car p1) (- (+ (cadr pk1) dt) r))
	 pln3 (list (+ (car p1) b) (- (+ (cadr pk1) dt) r))
	 pl21 (polar pk1 (+ (/ pi 2) alfa) dt)
	 pl31 (polar pk1 (- (/ pi 2) alfa) dt)
	p7n2 (list (car p1) (+ (cadr pk1) dt))
	p7n3 (list (+ (car p1) b) (+ (cadr pk1) dt))
	p722 (list (- (car pl21) r) (cadr pl21))
	p732 (list (+ (car pl31) r) (cadr pl31))
	p723 (list (car p722) (+ (cadr p722) r))
	p733 (list (car p732) (+ (cadr p732) r))
	 plv2 (list (car p1) (+ (- (cadr pk1) dt) r))
	 plv3 (list (+ (car p1) b) (+ (- (cadr pk1) dt) r))
	 pl22 (polar pk1 (- (* pi 1.5) alfa) dt)
	 pl32 (polar pk1 (+ (* pi 1.5) alfa) dt)
	p7v2 (list (car p1) (- (cadr pk1) dt))
	p7v3 (list (+ (car p1) b) (- (cadr pk1) dt))
	p724 (list (- (car pl22) r) (cadr pl22))
	p734 (list (+ (car pl32) r) (cadr pl32))
	p725 (list (car p724) (- (cadr p724) r))
	p735 (list (car p734) (- (cadr p734) r))
	 ps21 (list (- (car p725) (/ r 2)) (cadr p725))
	 ps22 (list (car ps21) (- (cadr p7n2) (/ r 2)))
	 ps23 (polar ps22 (/ pi 4) r)
	ps31 (list (+ (car p735) (/ r 2)) (cadr p735))
	ps32 (list (car ps31) (- (cadr p7n3) (/ r 2)))
	ps33 (polar ps32 (* pi 0.75) r)
  )
  (setvar "osmode" 0)
  (setvar "cecolor" "white")
  (setq SS (ssadd))
  (setq SS1 (ssadd))
  ;
  (command "pline" pv3 pn31 "a" pn32 "l" pn22 "a" pn21 "l" pv2 "")
  (ssadd (entlast) SS)
   (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
   (ssadd (entlast) SS1)
  (command "pline" pv21 "a" "_ce" pv23 pv22 "l" pv32 "a" "_ce" pv33 pv31 "")
  (ssadd (entlast) SS)
   (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
   (ssadd (entlast) SS1)
  ;
  (command "circle" pk1 dt)
  (ssadd (entlast) SS)
   (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
   (ssadd (entlast) SS1)
  (setvar "cecolor" "red")
  (setvar "celtype" "ACAD_ISO10W100")
  (command "line" (polar pk1 pi (+ dt 1)) (polar pk1 0 (+ dt 1)) "")
  (ssadd (entlast) SS)
   (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
   (ssadd (entlast) SS1)
  (command "line" (polar pk1 (* pi 0.5) (+ dt 1)) (polar pk1 (* pi 1.5) (+ dt 1)) "")
  (ssadd (entlast) SS)
   (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
   (ssadd (entlast) SS1)
  (setvar "celtype" oldtp)
  (setvar "cecolor" "white")
  (cond
    ((= no2 "0") ; 7242-81 
     (progn
      ; 
      (command "pline" p7n3 p733 p732 pl31 "a" "_ce" pk1 pl21 "l" p722 p723 p7n2 "")
      (ssadd (entlast) SS)
       (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
       (ssadd (entlast) SS1)
      (command "pline" p7v2 p725 p724 pl22 "a" "_ce" pk1 pl32 "l" p734 p735 p7v3 "")
      (ssadd (entlast) SS)
       (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
       (ssadd (entlast) SS1)
      ;
      (command "pline" ps21 ps22 ps23 "")
      (ssadd (entlast) SS)
       (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
       (ssadd (entlast) SS1)
      (command "pline" ps31 ps32 ps33 "")
      (ssadd (entlast) SS)
       (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
       (ssadd (entlast) SS1)
     )
    )
    ((= no2 "1") ; 8338-75
     (progn
      (command "pline" pln3 pl31 "a" "_ce" pk1 pl21 "l" pln2 "")
      (ssadd (entlast) SS)
       (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
       (ssadd (entlast) SS1)
      (command "pline" plv2 pl22 "a" "_ce" pk1 pl32 "l" plv3 "")
      (ssadd (entlast) SS)
       (command "mirror" (entlast) "" p1 (polar p1 0 1) "")
       (ssadd (entlast) SS1)       
     )
    )
  )
  
  (setvar "osmode" sosnap)
  (command "_rotate" SS SS1 "" p1 pause)
  (UnBlk_p p1 SS SS1)
  (setvar "cecolor" oldcl)
)

;===== ""=====

(defun abpr_p ( )
  (setq inf_p
    (list "                            "
	  "       7242-81"
	  "   8338-75"
	  "      \" -"
	  "  \" .. ."
	  "     :  "
	  "         , "
	  "     E-mail: klf02@yandex.ru"
   )
  )
  (if (not (new_dialog "inf_ps" DCL_ID)) (exit))
  (start_list "ab_ps")
  (mapcar 'add_list inf_p)
  (end_list)
  (action_tile  "accept" "(done_dialog)")
  (start_dialog)
)

;===== ""=====

(defun hlp_p ( )
  (setq help_p
    (list "     l   d      D     B      r        dt       d2   D2     C        Co       n        n"
          " --------l-------------------------------------------------------------------------------------------------------"
          "  200 l  10    30    9     1,0    5.95    15   25    469     266    20000   25000"
	  "  201 l  12    32   10    1,0    5.56    17   27    478     270    20000   25000"
	  "  202 l  15    35   11    1,0    5.95    20   30    597     354    16000   20000" 
	  "  203 l  17    40   12    1,0    7.14    22   35    752     477    16000   20000" 
	  "  204 l  20    47   14    1,5    7.94    26   41   1000    630    12500   16000" 
	  "  205 l  25    52   15    1,5    7.94    31   46   1100    709    10000   12500" 
	  "  206 l  30    62   16    1,5    9.53    36   56   1530   1020   10000   12500" 
	  "  207 l  35    72   17    2,0   11.11   42   65   2010   1390     8000   10000" 
	  "  208 l  40    80   18    2,0   12.70   47   73   2560   1810     6300    8000" 
	  "  209 l  45    85   19    2,0   12.70   52   78   2570   1810     6300    8000" 
	  "  210 l  50    90   20    2,0   12.70   57   83   2750   2020     6300    8000" 
	  "  211 l  55   100   21   2,5   14.29   64   91   3400   2560     5000    6300"
   )
  )
  (if (not (new_dialog "hlp_ps" DCL_ID)) (exit))
  (start_list "hl_ps")
  (mapcar 'add_list help_p)
  (end_list)
  (action_tile  "accept" "(done_dialog)")
  (start_dialog)
)

;====        =====
(defun UnBlk_p (pt ss ss1 / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 p1) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq count (- (sslength ss1) 1))
    (while (>= count 0)
        (setq Obj (ssname ss1 count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 p1) (cons 70 1)) )
    (setq insName (entmake insDat))
)